// Demo NIOSII 03-2011
// Christian Dupaty
// Demo IT
// Comptage en interruption TIMER sur LEDs LEDR[7..0] sur carte DE2, periode 0,5s

#include "sys/alt_stdio.h"
#include "system.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"
#include "sys/alt_irq.h"

// adresses relatives registres du TIMER (voir Quartus II Handbook 9.1 Volume 5 Chap 26 Interval Timer Core)
#define AD_STATUS 0
#define AD_CONTROL 1
#define AD_PERIODEL 2
#define AD_PERIODEH 3

volatile unsigned int contexte_pour_IT;	// sauvegarde du contexte de l'IT

static void timer_flash(void* context)
{static unsigned char n=0;
	// efface drapeau d'IT
	IOWR(TIMER_0_BASE,AD_STATUS,0);
	// incremente affichage sur LEDs
	IOWR(SORTIES_BASE,0,n++);

}

void main(void)
{
	// Timer_IT_ptr pointe sur adresse de sauvegarde du contexte
	void* Timer_IT_ptr= (void*) &contexte_pour_IT;
	// IT Timer toutes les 0,5s. (Periode comptage LEDs 1S)
	// OSC = 50Mhz , 0,5s=N*(1/50000000)   N=50000000d N=0x017D7840
	IOWR(TIMER_0_BASE,AD_PERIODEL,0x7840);
	IOWR(TIMER_0_BASE,AD_PERIODEH,0x017D);
	// Lance TIMER, Decomptage continu, declenche IT (0b00000111 = 7)
	IOWR(TIMER_0_BASE,AD_CONTROL,7);
	// configure le vecteur d'IT : (voir system.h) :
		// numero de la source d'IT, ici 0
		// numero de l'IT du TIMER, ici 0
		// fonction de gestion de l'IT
		// adresse octet de sauvegarde du contexte
		// indicateurs divers, ici 0 , il n'y en a pas
	alt_ic_isr_register(TIMER_0_IRQ_INTERRUPT_CONTROLLER_ID,TIMER_0_IRQ,timer_flash,Timer_IT_ptr,0);

	while(1); // attend interruption
}
